<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | Blank Page</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Users</a>
      </li>
    </ul>


  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Thanhlnd</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Bài làm Task 45.40
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
                <li class="nav-item">
                    <a href="Task 45.40.1.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Task 37.30</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="Task 45.40.2.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Task 37.40</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="Task 45.40.3.html" class="nav-link active">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Task 37.50</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="Task 45.40.4.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Task 37.60</p>
                    </a>
                  </li>
            </ul>
          </li>          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>User Sigh Up List</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Danh sách người dùng đăng ký</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
        <div class="container">
            <div class="text-center">
              <h1>Danh sách người dùng đăng ký</h1>
            </div>
            <div class="form-group">
              <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; Thêm User</button>
            </div>
          </div>
          <!-- Vouche Data Table -->
          <div class="container">
            <table class="table table-bordered table-striped table-hover" id="user-table">
              <thead>
                <tr>
                  <th>Id</th>
                  <th>Firstname</th>
                  <th>Lastname</th>
                  <th>Country</th>
                  <th>Subject</th>
                  <th>Customer Type</th>
                  <th>Register Status</th>
                  <th>Action</th>
                </tr>
              </thead>
            </table>
          </div>
          
          <!-- Vùng modal thêm user-->
          <div class="modal" tabindex="-1" role="dialog" id="modal-add-user">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h1 class="modal-title">Thêm User</h1>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <form>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>First name</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" id="inp-modal-add-user-fname" class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>Last name</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" id="inp-modal-add-user-lname" class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>Subject</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" id="inp-modal-add-user-subject" class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>Country</label>
                      </div>
                      <div class="col-sm-8">
                        <select name="" id="select-modal-add-user-country" class="form-control">
                          <option value="">Select Country</option>
                          <option value="VN">Việt Nam</option>
                          <option value="USA">USA</option>
                          <option value="AUS">Australia</option>
                          <option value="CAN">Canada</option>
                        </select>
                      </div>
                    </div>
                    <!-- <div class="row form-group">
                      <div class="col-sm-4">
                        <label>Customer Type</label>
                      </div>
                      <div class="col-sm-8">
                        <select name="" id="select-modal-add-user-customer" class="form-control">
                          <option value="Standard">Standard Nam</option>
                          <option value="Gold">Gold</option>
                          <option value="Premium">Premium</option>
                        </select>
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>Country</label>
                      </div>
                      <div class="col-sm-8">
                        <select name="" id="select-modal-add-user-status" class="form-control">
                          <option value="Accepted">Accepted</option>
                          <option value="Denied">Denied</option>
                          <option value="Standard">Standard</option>
                        </select>
                      </div>
                    </div> -->
                  </form>  
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-primary" id="btn-insert">Insert user</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
              </div>
            </div>
          </div>
          <!--Modal update user-->
          <div class="modal" tabindex="-1" role="dialog" id="modal-update-user">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h1 class="modal-title">Update User</h1>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <form>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>First name</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" id="inp-modal-update-user-fname" class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>Last name</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" id="inp-modal-update-user-lname" class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>Subject</label>
                      </div>
                      <div class="col-sm-8">
                        <input type="text" id="inp-modal-update-user-subject" class="form-control">
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>Country</label>
                      </div>
                      <div class="col-sm-8">
                        <select name="" id="select-modal-update-user-country" class="form-control">
                          <option value="">Select Country</option>
                          <option value="VN">Việt Nam</option>
                          <option value="USA">USA</option>
                          <option value="AUS">Australia</option>
                          <option value="CAN">Canada</option>
                        </select>
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>Customer Type</label>
                      </div>
                      <div class="col-sm-8">
                        <select name="" id="select-modal-update-user-customer" class="form-control">
                          <option value="">Select Type</option>
                          <option value="Standard">Standard</option>
                          <option value="Gold">Gold</option>
                          <option value="Premium">Premium</option>
                        </select>
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label>Register status</label>
                      </div>
                      <div class="col-sm-8">
                        <select name="" id="select-modal-update-user-status" class="form-control">
                          <option value="">Select Status</option>
                          <option value="Accepted">Accepted</option>
                          <option value="Denied">Denied</option>
                          <option value="Standard">Standard</option>
                        </select>
                      </div>
                    </div>
                  </form>  
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-primary" id="btn-update">Update user</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
              </div>
            </div>
          </div>
          
          <!--Modal comfirm xoá user-->
          
          <div class="modal fade" id="modal-delete-user" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="exampleModalLabel">Xác nhận</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  Bạn chắc chắn xoá user này chứ 😥😥😥 !!!
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-primary" id="btn-confirm">Confirm</button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
              </div>
            </div>
          </div>          
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>

</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>

​<script>
    const gID_COL = 0;
    const gFIRSTNAME_COL = 1;
    const gLASTNAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOM_COL = 5;
    const gSTATUS_COL = 6;
    const gACTION_COl = 7;
    const gBASE_URL = "http://42.115.221.44:8080/crud-api/users/";
    gId = "";
    gIdDelete = "";
    var gDataList = [];
    gUser = {
      firstname: "", 
      lastname: "", 
      subject: "", 
      country: ""
    }

    gUserFromTable = {
      firstname: "", 
      lastname: "", 
      subject: "", 
      country: "",
      customerType : "",
      registerStatus : ""
    }
    $(document).ready(function(){
      onPageLoading()
    });

    function onPageLoading(){
      "use strict";
      callApiToGetData()
      loadDataToTable(gDataList)
    }
   
    //Hàm call Api để lấy dữ liệu
    function callApiToGetData(){
        "use strict";
        $.ajax({
            url: gBASE_URL,
            type: 'GET',
            dataType: 'json', // added data type
            async: false,
            success: function (responseObject) {
              //console.log(JSON.stringify(responseObject));  //response text
              console.log("get data thành công!!!")
              //4 xử lý hiện thị
              gDataList = responseObject; 
              // responseObject là array các posts    
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText)
            }
        });    
    }


    //Hàm xử lý load dữ liệu vào bảng
    function loadDataToTable(paramData) {
        "use strict";
        var gNameCol = ["id","firstname", "lastname", "country", "subject", "customerType","registerStatus"];
        $('#user-table').DataTable( {
            data: paramData,
            columns: [
                { data: gNameCol[gID_COL] },
                { data: gNameCol[gFIRSTNAME_COL] },
                { data: gNameCol[gLASTNAME_COL] },
                { data: gNameCol[gCOUNTRY_COL] },
                { data: gNameCol[gSUBJECT_COL] },  
                { data: gNameCol[gCUSTOM_COL] },
                { data: gNameCol[gSTATUS_COL] },
                { data: gNameCol[gACTION_COl] },
            ],
            columnDefs:[        //định nghia các cột cần hiện ra
                {             
                targets : gID_COL,   //cột ID
                className : "text-center text-primary",
                },
                {
                targets : gFIRSTNAME_COL, 
                className : "text-center"
                },
                {
                targets : gLASTNAME_COL, 
                className : "text-center"
                },
                {
                targets : gCOUNTRY_COL, 
                className : "text-center"
                },
                {
                targets : gSUBJECT_COL, 
                className : "text-center"
                },
                {
                targets : gCUSTOM_COL, 
                className : "text-center"
                },
                {
                targets: gSTATUS_COL,
                className: "text-center text-danger",
                },
                {
                targets : gACTION_COl,  //cột Action
                className : "text-center",
                defaultContent: `<i class="fas fa-edit btn-edit" style="color:green;cursor:pointer;">
                  </i> &nbsp <i class="fas fa-trash-alt btn-delete" style="color:red;cursor:pointer;"></i>`
                }
            ],
            autoWidth : false
        });
    }

    $(document).on("click", "#user-table .btn-fix",function(){
        onBtnFixClick(this)
    })
    $(document).on("click", "#user-table .btn-delete",function(){
        onBtnDeleteClick(this)
    })

    //hàm xử lý nút sửa trên table
    function onBtnFixClick(paramElement){
        "use strict";
        console.log("Nút sửa được ấn !!!");
        var vRowClick = $(paramElement).closest("tr");
        var vTable = $("#user-table").DataTable();
        var vDataRow = vTable.row(vRowClick).data();
        console.log("ID của User được chọn : " + vDataRow.id);
    }

    //hàm xử lý nút xoá trên table
    function onBtnDeleteClick(paramElement){
        "use strict";
        console.log("Nút xoá được ấn !!!");
        var vRowClick = $(paramElement).closest("tr");
        var vTable = $("#user-table").DataTable();
        var vDataRow = vTable.row(vRowClick).data();
        console.log("ID của User được chọn : " + vDataRow.id);
    }   
    //hàm sự kiện nút thêm user
    $("#btn-add-user").click(function(){
      $("#modal-add-user").modal('show');
    })

    //hàm sự kiện nút insert user trên modal
    $("#btn-insert").click(function(){
      console.log("Nút insert user được ấn !!!")
      //B1 thu thập dữ liệu
      getDataOnModalAddUser(gUser)
      //B2 validate dữ liệu
      var vCheck = validateData(gUser);
      if(vCheck == true){
        console.log("Thông tin hợp lệ !!!")
        //B3 tạo thêm user
        callApiCreatUser(gUser);
        //B4 xoá trăng dữ liệu modal + tắt modal + load lại danh sách user
        //callapi + load data vào table
        callApiToGetData()
        //load lại table
        displayOnDatatable(gDataList)
        //xoá trăng dữ liệu trên modal
        emptyInsertUserModal();
        //ẩn insert user modal
        $("#modal-add-user").modal('hide');
      }

    })



    //hàm xử lý thu thập dữ liệu trên modal thêm user
    function getDataOnModalAddUser(paramData) {
      var vInpFirstName = $("#inp-modal-add-user-fname");
      var vInpLastName = $("#inp-modal-add-user-lname");
      var vInpSubject = $("#inp-modal-add-user-subject");
      var vInpCountry = $("#select-modal-add-user-country");

      paramData.firstname = vInpFirstName.val();
      paramData.lastname = vInpLastName.val();
      paramData.subject = vInpSubject.val();
      paramData.country = vInpCountry.val();

    }

    //Hàm validate thông tin user
    function validateData(paramData){
      "use strict";
      if(paramData.firstname == ""){
        alert("Không được để trống ô first name !!!")
        return false;
      }
      if(paramData.lastname == ""){
        alert("Không được để trống ô last name !!!")
        return false;
      }
      if(paramData.subject == ""){
        alert("Không được để trống ô subject !!!")
        return false;
      }
      if(paramData.country == ""){
        alert("Chưa chọn country !!!")
        return false;
      } return true;
    }

    //hàm call api để tạo mới user
    function callApiCreatUser(paramUser) {
      "use strict";
      $.ajax({
        type: 'POST',
        url: gBASE_URL,
        contentType: 'application/json',
        data: JSON.stringify(paramUser),
        async: false,
        success: function(data) {
            alert("Thêm user thành công !!!")
            console.log(data);
            alert(Object.entries(data))
        },
        error: function (ajaxContext) {
            alert(ajaxContext.responseText);
            console.log(ajaxContext);
            console.log("Có lỗi xảy ra khi thực hiện thêm user!!!");
        },
      });   
    }

    //hàm xử lý sự kiện xoá trắng modal
    function emptyInsertUserModal(){
      "use strict";
      $("#inp-modal-add-user-fname").val("");
      $("#inp-modal-add-user-lname").val("");
      $("#inp-modal-add-user-subject").val("");
      $("#select-modal-add-user-country").val("");
    }
    //Hàm xử lý load lại data table
    function displayOnDatatable (paramObjectData) {
      "use strict";
      console.log('load bảng thành công!!!')
      var vTable = $('#user-table').DataTable();
      vTable.clear();
      vTable.rows.add(paramObjectData);
      vTable.draw();
    }

    $(document).on('click','.btn-edit',function(){
        onBtnEditClick(this);
    })
    function onBtnEditClick(paramElement) {
      "use strict";
      var vRowClick = $(paramElement).closest("tr");
      var vTable = $('#user-table').DataTable();
      var vDataRow = vTable.row(vRowClick).data();
      gId = vDataRow.id;
      console.log(vDataRow);
      $('#modal-update-user').modal('show');
      //B1 thu thập dữ liệu
      loadDataFromTable(vDataRow)
      //
    }

    function loadDataFromTable(paramUser){
      "use strict";
      var vFirstname = $('#inp-modal-update-user-fname').val(paramUser.firstname);
      var vLastname = $('#inp-modal-update-user-lname').val(paramUser.lastname);
      var vSubject = $('#inp-modal-update-user-subject').val(paramUser.subject);
      var vCountry = $('#select-modal-update-user-country option:selected').text(paramUser.country).val('');
      var vCustomerType = $('#select-modal-update-user-customer option:selected').text(paramUser.customerType).val('');
      var vRegisterStatus = $('#select-modal-update-user-status option:selected').text(paramUser.registerStatus).val('');

    }

    $(document).on('click','#btn-update',function(){
      console.log("Nút update được ắn !!!");
      getDataFromModal(gUserFromTable);
      console.log(gUserFromTable);
      var vCheck = validateDataModal(gUserFromTable);
      if(vCheck == true){
        console.log("Thông tin dữ liệu ok!!!")
        callApiToUpdateUser(gUserFromTable)
        callApiToGetData()
        displayOnDatatable(gDataList);
        $('#modal-update-user').modal('hide');
      }
    })

    //hàm lấy thông tin dữ liệu trên modal update
    function getDataFromModal(paramData) {
      "use strict";
      paramData.firstname = $('#inp-modal-update-user-fname').val()
      paramData.lastname = $('#inp-modal-update-user-lname').val()
      paramData.subject = $('#inp-modal-update-user-subject').val()
      paramData.country = $('#select-modal-update-user-country').val()
      paramData.customerType = $('#select-modal-update-user-customer').val()
      paramData.registerStatus = $('#select-modal-update-user-status').val()
    }

    //hàm validate dữ liệu modal
    function validateDataModal(paramData){
      "use strict";
      if(paramData.firstname == ""){
        alert('Không được để trống first name !!!');
        return false;
      }
      if(paramData.lastname == ""){
        alert('Không được để trống last name !!!');
        return false;
      }
      if(paramData.subject == ""){
        alert('Không được để trống subject !!!');
        return false;
      }
      if(paramData.country == ""){
        alert('Chưa chọn lại country !!!');
        return false;
      }
      if(paramData.customerType == ""){
        alert('Chưa chọn lại Customer Type !!!');
        return false;
      }
      if(gUserFromTable.registerStatus == ""){
        alert('Chưa chọn lại Register Status !!!');
        return false;
      }return true;
    }

  //hàm call api to update user
    function callApiToUpdateUser(paramUser){
      "use strict"
      $.ajax({
        type: 'PUT',
        url: gBASE_URL + gId,
        contentType: 'application/json',
        data: JSON.stringify(paramUser),
        async: false,
        success: function(data) {
            alert("Update user thành công !!!")
            console.log(data);
            alert(Object.entries(data))
        },
        error: function (ajaxContext) {
            alert(ajaxContext.responseText);
            console.log(ajaxContext);
            console.log("Có lỗi xảy ra khi thực hiện update user!!!");
        },
      }); 
    }

</script>
</body>
</html>
